'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _domLib = require('dom-lib');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _decorate = require('./utils/decorate');

var _decorate2 = _interopRequireDefault(_decorate);

var _clamp = require('./utils/clamp');

var _clamp2 = _interopRequireDefault(_clamp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  height: _react.PropTypes.number,
  initialEvent: _react.PropTypes.object,
  columnWidth: _react.PropTypes.number,
  columnLeft: _react.PropTypes.number,
  columnFixed: _react.PropTypes.bool,
  onColumnResizeStart: _react.PropTypes.func,
  onColumnResizeEnd: _react.PropTypes.func,
  onColumnResizeMove: _react.PropTypes.func
};

var ColumnResizeHandler = function (_React$Component) {
  _inherits(ColumnResizeHandler, _React$Component);

  function ColumnResizeHandler(props) {
    _classCallCheck(this, ColumnResizeHandler);

    var _this = _possibleConstructorReturn(this, (ColumnResizeHandler.__proto__ || Object.getPrototypeOf(ColumnResizeHandler)).call(this, props));

    _this.onColumnResizeMouseDown = _this.onColumnResizeMouseDown.bind(_this);
    _this.onMove = _this.onMove.bind(_this);
    _this.onColumnResizeEnd = _this.onColumnResizeEnd.bind(_this);
    _this.columnWidth = props.columnWidth || 0;
    _this.cursorDelta = 0;
    return _this;
  }

  _createClass(ColumnResizeHandler, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      if (this.isKeyDown && nextProps.initialEvent && !this.mouseMoveTracker.isDragging()) {
        this.mouseMoveTracker.captureMouseMoves(nextProps.initialEvent);
      }
      if (nextProps.columnWidth !== this.props.columnWidth) {
        this.columnWidth = nextProps.columnWidth;
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.mouseMoveTracker) {
        this.mouseMoveTracker.releaseMouseMoves();
        this.mouseMoveTracker = null;
      }
    }
  }, {
    key: 'onMove',
    value: function onMove(deltaX) {

      if (!this.isKeyDown) {
        return;
      }

      var _props = this.props,
          onColumnResizeMove = _props.onColumnResizeMove,
          columnWidth = _props.columnWidth,
          columnLeft = _props.columnLeft,
          columnFixed = _props.columnFixed;


      this.cursorDelta += deltaX;
      this.columnWidth = (0, _clamp2.default)(columnWidth + this.cursorDelta, 20);
      onColumnResizeMove && onColumnResizeMove(this.columnWidth, columnLeft, columnFixed);
    }
  }, {
    key: 'onColumnResizeEnd',
    value: function onColumnResizeEnd() {
      var onColumnResizeEnd = this.props.onColumnResizeEnd;

      this.isKeyDown = false;
      onColumnResizeEnd && onColumnResizeEnd(this.columnWidth, this.cursorDelta);

      if (this.mouseMoveTracker) {
        this.mouseMoveTracker.releaseMouseMoves();
        this.mouseMoveTracker = null;
      }
    }
  }, {
    key: 'onColumnResizeMouseDown',
    value: function onColumnResizeMouseDown(event) {
      var onColumnResizeStart = this.props.onColumnResizeStart;

      this.mouseMoveTracker = this.getMouseMoveTracker();
      this.isKeyDown = true;
      this.cursorDelta = 0;

      onColumnResizeStart && onColumnResizeStart({
        clientX: event.clientX,
        clientY: event.clientY,
        preventDefault: function preventDefault() {}
      });
    }
  }, {
    key: 'getMouseMoveTracker',
    value: function getMouseMoveTracker() {
      return this.mouseMoveTracker || new _domLib.DOMMouseMoveTracker(this.onMove, this.onColumnResizeEnd, document.body);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          _props2$columnLeft = _props2.columnLeft,
          columnLeft = _props2$columnLeft === undefined ? 0 : _props2$columnLeft,
          height = _props2.height,
          className = _props2.className,
          style = _props2.style,
          props = _objectWithoutProperties(_props2, ['columnLeft', 'height', 'className', 'style']);

      var styles = _extends({
        width: 6,
        left: this.columnWidth + columnLeft - 2,
        height: height
      }, style);

      var classes = (0, _classnames2.default)(this.prefix('column-resize-spanner'), className);
      var elementProps = _lodash2.default.omit(props, Object.keys(propTypes));

      return _react2.default.createElement('div', _extends({}, elementProps, {
        className: classes,
        style: styles,
        onMouseDown: this.onColumnResizeMouseDown,
        role: 'button',
        tabIndex: -1
      }));
    }
  }]);

  return ColumnResizeHandler;
}(_react2.default.Component);

ColumnResizeHandler.propTypes = propTypes;

exports.default = (0, _decorate2.default)()(ColumnResizeHandler);