'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Cell = require('./Cell');

var _Cell2 = _interopRequireDefault(_Cell);

var _ColumnResizeHandler = require('./ColumnResizeHandler');

var _ColumnResizeHandler2 = _interopRequireDefault(_ColumnResizeHandler);

var _isNullOrUndefined = require('./utils/isNullOrUndefined');

var _isNullOrUndefined2 = _interopRequireDefault(_isNullOrUndefined);

var _decorate = require('./utils/decorate');

var _decorate2 = _interopRequireDefault(_decorate);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = _extends({}, _Cell2.default.propTypes, {
  sortable: _propTypes2.default.bool,
  resizable: _propTypes2.default.bool,
  onColumnResizeEnd: _propTypes2.default.func,
  onColumnResizeStart: _propTypes2.default.func,
  onColumnResizeMove: _propTypes2.default.func,
  onSortColumn: _propTypes2.default.func,
  headerHeight: _propTypes2.default.number
});

var HeaderCell = function (_React$Component) {
  _inherits(HeaderCell, _React$Component);

  function HeaderCell(props) {
    _classCallCheck(this, HeaderCell);

    var _this = _possibleConstructorReturn(this, (HeaderCell.__proto__ || Object.getPrototypeOf(HeaderCell)).call(this, props));

    _this.state = {
      columnWidth: (0, _isNullOrUndefined2.default)(props.flexGrow) ? props.width : 0
    };
    _this.handleClick = _this.handleClick.bind(_this);
    _this.onColumnResizeStart = _this.onColumnResizeStart.bind(_this);
    _this.onColumnResizeEnd = _this.onColumnResizeEnd.bind(_this);
    return _this;
  }

  _createClass(HeaderCell, [{
    key: 'onColumnResizeStart',
    value: function onColumnResizeStart(event) {
      var _props = this.props,
          left = _props.left,
          fixed = _props.fixed,
          onColumnResizeStart = _props.onColumnResizeStart;


      this.setState({ initialEvent: event });
      onColumnResizeStart && onColumnResizeStart(this.state.columnWidth, left, fixed);
    }
  }, {
    key: 'onColumnResizeEnd',
    value: function onColumnResizeEnd(columnWidth, cursorDelta) {
      var _props2 = this.props,
          dataKey = _props2.dataKey,
          index = _props2.index,
          onColumnResizeEnd = _props2.onColumnResizeEnd;

      this.setState({ columnWidth: columnWidth });
      onColumnResizeEnd && onColumnResizeEnd(columnWidth, cursorDelta, dataKey, index);
    }
  }, {
    key: 'handleClick',
    value: function handleClick() {
      var _props3 = this.props,
          sortable = _props3.sortable,
          dataKey = _props3.dataKey,
          sortType = _props3.sortType,
          onSortColumn = _props3.onSortColumn;

      sortable && onSortColumn && onSortColumn(dataKey, sortType === 'asc' ? 'desc' : 'asc');
    }
  }, {
    key: 'renderResizeSpanner',
    value: function renderResizeSpanner() {
      var _props4 = this.props,
          resizable = _props4.resizable,
          left = _props4.left,
          onColumnResizeMove = _props4.onColumnResizeMove,
          fixed = _props4.fixed,
          headerHeight = _props4.headerHeight;
      var _state = this.state,
          columnWidth = _state.columnWidth,
          initialEvent = _state.initialEvent;


      if (!resizable) {
        return null;
      }

      return _react2.default.createElement(_ColumnResizeHandler2.default, {
        columnWidth: columnWidth,
        columnLeft: left,
        columnFixed: fixed,
        height: headerHeight,
        initialEvent: initialEvent,
        onColumnResizeMove: onColumnResizeMove,
        onColumnResizeStart: this.onColumnResizeStart,
        onColumnResizeEnd: this.onColumnResizeEnd
      });
    }
  }, {
    key: 'renderSortColumn',
    value: function renderSortColumn() {
      var _props5 = this.props,
          left = _props5.left,
          headerHeight = _props5.headerHeight,
          sortable = _props5.sortable,
          sortColumn = _props5.sortColumn,
          sortType = _props5.sortType,
          dataKey = _props5.dataKey,
          width = _props5.width;
      var columnWidth = this.state.columnWidth;

      var styles = {
        left: (columnWidth || width) + left - 16,
        top: headerHeight / 2 - 8
      };

      if (sortable) {
        return _react2.default.createElement(
          'div',
          {
            style: styles,
            className: this.prefix('sortable')
          },
          _react2.default.createElement('i', { className: sortColumn === dataKey ? 'icon icon-sort-' + sortType : 'icon icon-sort' })
        );
      }

      return null;
    }
  }, {
    key: 'render',
    value: function render() {

      var classes = this.prefix('cell-header');

      return _react2.default.createElement(
        'div',
        { className: classes },
        _react2.default.createElement(_Cell2.default, _extends({}, this.props, {
          isHeaderCell: true,
          onClick: this.handleClick
        })),
        this.renderSortColumn(),
        this.renderResizeSpanner()
      );
    }
  }]);

  return HeaderCell;
}(_react2.default.Component);

HeaderCell.propTypes = propTypes;

exports.default = (0, _decorate2.default)()(HeaderCell);